# DullahanFeeModule

### UNIT

```solidity
uint256 UNIT
```

1e18 scale

### TRESHOLD

```solidity
uint256 TRESHOLD
```

Threshold ratio to apply the extra multiplier

### BASE\_MULTIPLIER

```solidity
uint256 BASE_MULTIPLIER
```

Base extra multiplier

### EXTRA\_MULTIPLIER\_STEP

```solidity
uint256 EXTRA_MULTIPLIER_STEP
```

Multplier increase for extra ratio over the treshold

### vault

```solidity
address vault
```

Address of the Dullahan Vault

### feePerStkAavePerSecond

```solidity
uint256 feePerStkAavePerSecond
```

Amount of GHO fees per second per stkAAVE

### UpdatedFeePerStkAavePerSecond

```solidity
event UpdatedFeePerStkAavePerSecond(uint256 oldFee, uint256 newFee)
```

Event emitted when the fee per second value is updated

### constructor

```solidity
constructor(address _vault, uint256 _startFee) public
```

### utilizationRate

```solidity
function utilizationRate() public view returns (uint256)
```

Get the current utilization rate

*Calculates the current utilization rate based on the Vault rented amount & total assets*

#### Return Values

| Name | Type    | Description                        |
| ---- | ------- | ---------------------------------- |
| \[0] | uint256 | uint256 : Current utilization rate |

### getCurrentFeePerSecond

```solidity
function getCurrentFeePerSecond() external view returns (uint256 currentFee)
```

Get the current fee per second

*Calculates the current fee per second based on the current utilization rate*

#### Return Values

| Name       | Type    | Description                        |
| ---------- | ------- | ---------------------------------- |
| currentFee | uint256 | - uint256 : Current fee per second |

### updateFeePerStkAavePerSecond

```solidity
function updateFeePerStkAavePerSecond(uint256 newFee) external
```

Updates the feePerStkAavePerSecond parameter

*Updates the feePerStkAavePerSecond in storage with the given value*

#### Parameters

| Name   | Type    | Description      |
| ------ | ------- | ---------------- |
| newFee | uint256 | New value tu set |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.paladin.vote/dullahan/smart-contracts/dullahanfeemodule.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
